/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	D同期処理　共通エラークラス
//			変更履歴
//				2004.01.08	新規作成	            二條智文
//
package jp.co.ntt.lms.xmo.Ad;

import jp.co.ntt.lms.xmo.MessageData;
import jp.co.ntt.lms.xmo.XMOException;
import jp.co.ntt.lms.xmo.Message.MessageClient;

/**
 * AD同期処理　共通エラークラス<BR>
 * AD同期処理で発生するエラーはすべてこのクラスを継承します。
 */
public class ADCorpException extends XMOException implements ADCorpMessage {

	// メッセージIDを保持します
	protected String pstrErrNum;

	// 詳細メッセージを保持します。
	protected String mstrDetailMessage;

	/**
	 * コンストラクタです。<BR>
	 * メッセージIDを渡して設定します
	 * @param strMessageID メッセージID
	 */
	public ADCorpException( String strMessageID ) {
		this(strMessageID, "");
	}

	/**
	 * コンストラクタです。<BR>
	 * メッセージIDと詳細メッセージを渡して設定します
	 * @param strMessageID メッセージID
	 * @param strDetailMessage 詳細メッセージ
	 */
	public ADCorpException( String strMessageID, String strDetailMessage ) {
		super( strMessageID );
		pstrErrNum = strMessageID;
		// メッセージをロードします。
		loadMessage();

		mstrDetailMessage = strDetailMessage;
	}

	/**
	 * コンストラクタです。<BR>
	 * メッセージデータを渡して設定します
	 * @param objMessageData メッセージデータ
	 */
	public ADCorpException( MessageData objMessageData ) {
		super( objMessageData.getMessageID() );
		pstrErrNum = objMessageData.getMessageID();
		pobjMessageData = objMessageData;
	}

	/**
	 * メッセージを取得します。
	 * @return String メッセージ
	 */
	public String getMessage() {

		String strRes = null;
		if( pobjMessageData != null ) {
			strRes = pobjMessageData.getMessage();
		}

		return strRes;
	}

	/**
	 * メッセージデータを設定
	 * @param objmessageData メッセージデータ
	 */
	public void setMessageData( MessageData objMessageData ) {

		pobjMessageData = objMessageData;
	}

	/**
	 * 詳細メッセージを取得します。
	 * @return String 詳細メッセージ
	 */
	public String getDetailMessage() {
		return mstrDetailMessage;
	}

	/**
	 * メッセージファイルからメッセージを取得します。
	 */
	private void loadMessage() {
		try {
			MessageClient objMsgClient = new MessageClient(MSG_FIEL_PATH,
															MSG_FILE_NAME);
			pobjMessageData = objMsgClient.getMessageData( pstrErrNum );
		}
		catch(Exception e) {
			// メッセージ取得でエラーが発生した場合は、システムエラーとする。
			pobjMessageData = new MessageData();
			pobjMessageData.setMessageID( SYSTEM_ERR );
			pobjMessageData.setMessage( "システムエラーが発生しました。" );
		}
	}


}
